unit DConsole;

interface

uses Classes, Windows, SysUtils, controls;

type
  TDebugConsole = class(TComponent)
  private
    FTitle: string;
    FEnabled: Boolean;
    procedure SetTitle(Value: string);
    procedure SetEnabled(Value: Boolean);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Enabled: Boolean read FEnabled write SetEnabled;
    property Title: string read FTitle write SetTitle;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Additional', [TDebugConsole]);
end;

constructor TDebugConsole.Create(AOwner: TComponent);
begin
  inherited;
  FTitle := '';
  FEnabled := False;
end;

destructor TDebugConsole.Destroy;
begin
  if FEnabled then begin
    FreeConsole;
  end;
  inherited;
end;

procedure TDebugConsole.SetEnabled(Value: Boolean);
begin
  if FEnabled <> Value then begin
    FEnabled := Value;
    if FEnabled then begin
      AllocConsole;
      SetConsoleTitle(PChar(FTitle));
    end
    else begin
      FreeConsole;
    end;
  end;
end;

procedure TDebugConsole.SetTitle(Value: string);
begin
  if (Value <> FTitle) then begin
    FTitle := Value;
    if FEnabled then SetConsoleTitle(PChar(FTitle));
  end;
end;

end.
